######################################################################################################
# This Program is written by Giga Pardaz PARS
# PICO ROBOT with Mohandesika Two Wheel Robot CHasis
# CRR-PICO VER 1.5
# Universal Interface VER1.0
# MDRV DC Motor Drive VER1.1
# Esfand 1401
######################################################################################################

from machine import Pin
from hcsr04 import HCSR04
import time
from utime import sleep

sensor = HCSR04(trigger_pin=26, echo_pin=2, echo_timeout_us=10000)
LED = Pin(25,Pin.OUT)

######################################################################################################

def dist_cm():
    try:
        global dist, Obstacle
        dist = sensor.distance_cm()
       
        time.sleep_us(50)
        if dist > 15 :
            Obstacle = False
            LED.value(1)
        else:
            Obstacle = True
            LED.value(0)
            
    except OSError as ex:
        print('ERROR getting distance:', ex)

    return dist, Obstacle

######################################################################################################
