######################################################################################################
# This Program is written by Giga Pardaz PARS
# PICO ROBOT with Mohandesika Two Wheel Robot CHasis
# CRR-PICO VER 1.5
# Universal Interface VER1.0
# MDRV DC Motor Drive VER1.1
# Esfand 1401
######################################################################################################

from machine import Pin, I2C, PWM, Timer , UART
import time
from utime import sleep
import ssd1306
from ssd1306 import SSD1306_I2C
import MDrive
import RGB_LED
import Distance
import OLED

######################################################################################################

uart = UART(0, baudrate=9600, tx=Pin(0), rx=Pin(1))
KEY = machine.Pin(15, machine.Pin.IN)
Interrupt=Pin(15,Pin.IN)   # setting GPIO15 KEY_Interrupt as input
Buzzer = PWM(Pin(11))
Buzzer.freq(2000)

dist = 0
run = False
Obstacle = True
Move_State = 'Stop'
#global Control
Control = 'Auto'
Obstacle_Counnter = 0 
speed = 50

######################################################################################################

def handle_interrupt(Pin):           
    
    global run
    if Control == 'Auto':
        speed = 50
        
        if run == False:
            run = True
            
        else:
            run = False
            
    return

Interrupt.irq(trigger=Pin.IRQ_RISING, handler=handle_interrupt)

######################################################################################################

def State_Info():
    global speed, Move_State

    if Control == 'Auto':
        if  Move_State != 'stop_motor':
            OLED.Display(0,'PICO ROBO: Auto',str(Move_State) + ' SP:'+ str(speed) )
            print('PICO ROBO: Auto',Move_State, 'Speed:',speed)
        
        else:    
            OLED.Display(0,'PICO ROBO: Auto',str(Move_State) + ' SP:'+'0')
            print('PICO ROBO: Auto',Move_State, 'Speed:',' 0')
        
    if Control == 'Manual':
        if Move_State != 'stop_motor':
            OLED.Display(0,'PICO ROBO: Manual',str(Move_State) + ' SP:'+ str(speed))
            print('PICO ROBO: Manual',Move_State, 'Speed:',speed)
        
        else:    
            OLED.Display(0,'PICO ROBO: Auto',str(Move_State) + ' SP:'+'0')
            print('PICO ROBO: Auto',Move_State, 'Speed:',' 0')
        
    return

######################################################################################################

timer1=Timer(-1)
timer1.init(period=500, mode=Timer.PERIODIC,callback=lambda t: State_Info())

######################################################################################################
MDrive.setup()
sleep(.5)
#alarm()
RGB_LED.fill('Stop')
[dist, Obstacle]= Distance.dist_cm()
print('setup done.','Distance:', dist, 'cm')

while(True):
    
    if uart.any() > 0:
        data = uart.read()
        print(data)
        
        if "Auto" in data:
            Control ="Auto"
            print("Auto")
                
        if "Manual" in data:
            Control ="Manual"
            print("Manual")
            
    if Control == 'Manual':
        try:
            if int(data)<110:
                speed = int(data)
                print(input_data,speed)
        except:
             pass

            
        if "forward" in data:
            Move_State = MDrive.forward(speed)

        if "backward" in data:
            Move_State = MDrive.backward(speed)
        
        if "left" in data:
            Move_State = MDrive.turn_left()
        
        if "right" in data:
            Move_State = MDrive.turn_right()                

        if "stop" in data:
            Move_State = MDrive.stop_motor()
       

    if Control == 'Auto':

            if run == True:                
                [dist,Obstacle] = Distance.dist_cm()
                
                if (Obstacle == False):                    
                    Move_State = MDrive.forward(speed)
                    
                else:                    
                    [Obstacle, Obstacle_Counnter] = MDrive.OBST(Obstacle, Obstacle_Counnter)

            else:                
                Move_State = MDrive.stop_motor()



